#target indesign
#targetengine 'stock-photo'

var ffname = 'stock-photo';
var prefix = 'shutterstock_';
var ext = 'tif';

function getLinksByName (doc, name) {
	var res = [];
	for (var i = 0; i < doc.links.length; i++) {
		var link = doc.links[i];
		var file = File(link.filePath);
		if (decodeURI(file.name.toString()).indexOf(name) == 0) {
			res.push(link);
		}
	}
	return res;
}

function main () {
	try {
		var doc = app.activeDocument;
	} catch (error) {
		alert('Нет открытых документов!');
		return false;
	}

	var links = getLinksByName(doc, ffname);
	if (links.length == 0) {
		alert('Не обнаружены связанные файлы, имена которых начинаются на "' + ffname +'"');
		return false;
	}
	var fldr = File(links[0].filePath).parent.selectDlg('Выберите папку с файлами для замены');
	if (!fldr) {
		return false;
	}

	var wrong = [];

	for (var i = 0; i < links.length; i++) {
		var link = links[i];
		var file = File(link.filePath);
		var fname = decodeURI(file.name.toString()).replace(/\.[^\.]+$/gim, '');
		var rep_num = fname.replace(/.+[^\d]+([\d]+$)/gim, '$1');
		var rep_name = prefix + rep_num + '.' + ext;
		var rep_file = File(fldr + '/' + rep_name);
		if (rep_file.exists) {
			link.relink(rep_file);
		} else {
			wrong.push(rep_name);
		}
	}

	if (wrong.length != 0) {
		var str = 'Не нейдены:\n' + '"' + wrong.join('", "') + '"';
		alert(str);
	}
}

main();